Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4440)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4441)
@@ -23,5 +23,7 @@
 ! Current revisions:
 ! ------------------
-! 
+! - Change order of dimension in surface arrays %frac, %emissivity and %albedo 
+!   to allow for better vectorization in the radiation interactions.
+! - Minor formatting issues
 ! 
 ! Former revisions:
@@ -1831,9 +1833,9 @@
 !--       via namelist paramter, unless not already allocated.
           IF ( .NOT. ALLOCATED(surf_lsm_h%albedo) )  THEN
-             ALLOCATE( surf_lsm_h%albedo(0:2,1:surf_lsm_h%ns)     )
+             ALLOCATE( surf_lsm_h%albedo(1:surf_lsm_h%ns,0:2)     )
              surf_lsm_h%albedo    = albedo
           ENDIF
           IF ( .NOT. ALLOCATED(surf_usm_h%albedo) )  THEN
-             ALLOCATE( surf_usm_h%albedo(0:2,1:surf_usm_h%ns)     )
+             ALLOCATE( surf_usm_h%albedo(1:surf_usm_h%ns,0:2)     )
              surf_usm_h%albedo    = albedo
           ENDIF
@@ -1841,9 +1843,9 @@
           DO  l = 0, 3
              IF ( .NOT. ALLOCATED( surf_lsm_v(l)%albedo ) )  THEN
-                ALLOCATE( surf_lsm_v(l)%albedo(0:2,1:surf_lsm_v(l)%ns) )
+                ALLOCATE( surf_lsm_v(l)%albedo(1:surf_lsm_v(l)%ns,0:2) )
                 surf_lsm_v(l)%albedo = albedo
              ENDIF
              IF ( .NOT. ALLOCATED( surf_usm_v(l)%albedo ) )  THEN
-                ALLOCATE( surf_usm_v(l)%albedo(0:2,1:surf_usm_v(l)%ns) )
+                ALLOCATE( surf_usm_v(l)%albedo(1:surf_usm_v(l)%ns,0:2) )
                 surf_usm_v(l)%albedo = albedo
              ENDIF
@@ -1855,48 +1857,48 @@
 !--       albedo won't be overwritten. 
           DO  m = 1, surf_lsm_h%ns
-             IF ( surf_lsm_h%albedo_type(ind_veg_wall,m) /= 0 )                &
-                surf_lsm_h%albedo(ind_veg_wall,m) =                            &
-                           albedo_pars(0,surf_lsm_h%albedo_type(ind_veg_wall,m))
-             IF ( surf_lsm_h%albedo_type(ind_pav_green,m) /= 0 )               &
-                surf_lsm_h%albedo(ind_pav_green,m) =                           &
-                           albedo_pars(0,surf_lsm_h%albedo_type(ind_pav_green,m))
-             IF ( surf_lsm_h%albedo_type(ind_wat_win,m) /= 0 )                 &
-                surf_lsm_h%albedo(ind_wat_win,m) =                             &
-                           albedo_pars(0,surf_lsm_h%albedo_type(ind_wat_win,m))
+             IF ( surf_lsm_h%albedo_type(m,ind_veg_wall) /= 0 )                &
+                surf_lsm_h%albedo(m,ind_veg_wall) =                            &
+                           albedo_pars(0,surf_lsm_h%albedo_type(m,ind_veg_wall))
+             IF ( surf_lsm_h%albedo_type(m,ind_pav_green) /= 0 )               &
+                surf_lsm_h%albedo(m,ind_pav_green) =                           &
+                           albedo_pars(0,surf_lsm_h%albedo_type(m,ind_pav_green))
+             IF ( surf_lsm_h%albedo_type(m,ind_wat_win) /= 0 )                 &
+                surf_lsm_h%albedo(m,ind_wat_win) =                             &
+                           albedo_pars(0,surf_lsm_h%albedo_type(m,ind_wat_win))
           ENDDO
           DO  m = 1, surf_usm_h%ns
-             IF ( surf_usm_h%albedo_type(ind_veg_wall,m) /= 0 )                &
-                surf_usm_h%albedo(ind_veg_wall,m) =                            &
-                           albedo_pars(0,surf_usm_h%albedo_type(ind_veg_wall,m))
-             IF ( surf_usm_h%albedo_type(ind_pav_green,m) /= 0 )               &
-                surf_usm_h%albedo(ind_pav_green,m) =                           &
-                           albedo_pars(0,surf_usm_h%albedo_type(ind_pav_green,m))
-             IF ( surf_usm_h%albedo_type(ind_wat_win,m) /= 0 )                 &
-                surf_usm_h%albedo(ind_wat_win,m) =                             &
-                           albedo_pars(0,surf_usm_h%albedo_type(ind_wat_win,m))
+             IF ( surf_usm_h%albedo_type(m,ind_veg_wall) /= 0 )                &
+                surf_usm_h%albedo(m,ind_veg_wall) =                            &
+                           albedo_pars(0,surf_usm_h%albedo_type(m,ind_veg_wall))
+             IF ( surf_usm_h%albedo_type(m,ind_pav_green) /= 0 )               &
+                surf_usm_h%albedo(m,ind_pav_green) =                           &
+                           albedo_pars(0,surf_usm_h%albedo_type(m,ind_pav_green))
+             IF ( surf_usm_h%albedo_type(m,ind_wat_win) /= 0 )                 &
+                surf_usm_h%albedo(m,ind_wat_win) =                             &
+                           albedo_pars(0,surf_usm_h%albedo_type(m,ind_wat_win))
           ENDDO
 
           DO  l = 0, 3
              DO  m = 1, surf_lsm_v(l)%ns
-                IF ( surf_lsm_v(l)%albedo_type(ind_veg_wall,m) /= 0 )          &
-                   surf_lsm_v(l)%albedo(ind_veg_wall,m) =                      &
-                        albedo_pars(0,surf_lsm_v(l)%albedo_type(ind_veg_wall,m))
-                IF ( surf_lsm_v(l)%albedo_type(ind_pav_green,m) /= 0 )         &
-                   surf_lsm_v(l)%albedo(ind_pav_green,m) =                     &
-                        albedo_pars(0,surf_lsm_v(l)%albedo_type(ind_pav_green,m))
-                IF ( surf_lsm_v(l)%albedo_type(ind_wat_win,m) /= 0 )           &
-                   surf_lsm_v(l)%albedo(ind_wat_win,m) =                       &
-                        albedo_pars(0,surf_lsm_v(l)%albedo_type(ind_wat_win,m))
+                IF ( surf_lsm_v(l)%albedo_type(m,ind_veg_wall) /= 0 )          &
+                   surf_lsm_v(l)%albedo(m,ind_veg_wall) =                      &
+                        albedo_pars(0,surf_lsm_v(l)%albedo_type(m,ind_veg_wall))
+                IF ( surf_lsm_v(l)%albedo_type(m,ind_pav_green) /= 0 )         &
+                   surf_lsm_v(l)%albedo(m,ind_pav_green) =                     &
+                        albedo_pars(0,surf_lsm_v(l)%albedo_type(m,ind_pav_green))
+                IF ( surf_lsm_v(l)%albedo_type(m,ind_wat_win) /= 0 )           &
+                   surf_lsm_v(l)%albedo(m,ind_wat_win) =                       &
+                        albedo_pars(0,surf_lsm_v(l)%albedo_type(m,ind_wat_win))
              ENDDO
              DO  m = 1, surf_usm_v(l)%ns
-                IF ( surf_usm_v(l)%albedo_type(ind_veg_wall,m) /= 0 )          &
-                   surf_usm_v(l)%albedo(ind_veg_wall,m) =                      &
-                        albedo_pars(0,surf_usm_v(l)%albedo_type(ind_veg_wall,m))
-                IF ( surf_usm_v(l)%albedo_type(ind_pav_green,m) /= 0 )         &
-                   surf_usm_v(l)%albedo(ind_pav_green,m) =                     &
-                        albedo_pars(0,surf_usm_v(l)%albedo_type(ind_pav_green,m))
-                IF ( surf_usm_v(l)%albedo_type(ind_wat_win,m) /= 0 )           &
-                   surf_usm_v(l)%albedo(ind_wat_win,m) =                       &
-                        albedo_pars(0,surf_usm_v(l)%albedo_type(ind_wat_win,m))
+                IF ( surf_usm_v(l)%albedo_type(m,ind_veg_wall) /= 0 )          &
+                   surf_usm_v(l)%albedo(m,ind_veg_wall) =                      &
+                        albedo_pars(0,surf_usm_v(l)%albedo_type(m,ind_veg_wall))
+                IF ( surf_usm_v(l)%albedo_type(m,ind_pav_green) /= 0 )         &
+                   surf_usm_v(l)%albedo(m,ind_pav_green) =                     &
+                        albedo_pars(0,surf_usm_v(l)%albedo_type(m,ind_pav_green))
+                IF ( surf_usm_v(l)%albedo_type(m,ind_wat_win) /= 0 )           &
+                   surf_usm_v(l)%albedo(m,ind_wat_win) =                       &
+                        albedo_pars(0,surf_usm_v(l)%albedo_type(m,ind_wat_win))
              ENDDO
           ENDDO
@@ -1913,7 +1915,7 @@
                 j = surf_lsm_h%j(m)
                 IF ( albedo_pars_f%pars_xy(0,j,i) /= albedo_pars_f%fill )  THEN
-                   surf_lsm_h%albedo(ind_veg_wall,m)  = albedo_pars_f%pars_xy(0,j,i)
-                   surf_lsm_h%albedo(ind_pav_green,m) = albedo_pars_f%pars_xy(0,j,i)
-                   surf_lsm_h%albedo(ind_wat_win,m)   = albedo_pars_f%pars_xy(0,j,i)
+                   surf_lsm_h%albedo(m,ind_veg_wall)  = albedo_pars_f%pars_xy(0,j,i)
+                   surf_lsm_h%albedo(m,ind_pav_green) = albedo_pars_f%pars_xy(0,j,i)
+                   surf_lsm_h%albedo(m,ind_wat_win)   = albedo_pars_f%pars_xy(0,j,i)
                 ENDIF
              ENDDO
@@ -1922,7 +1924,7 @@
                 j = surf_usm_h%j(m)
                 IF ( albedo_pars_f%pars_xy(0,j,i) /= albedo_pars_f%fill )  THEN
-                   surf_usm_h%albedo(ind_veg_wall,m)  = albedo_pars_f%pars_xy(0,j,i)
-                   surf_usm_h%albedo(ind_pav_green,m) = albedo_pars_f%pars_xy(0,j,i)
-                   surf_usm_h%albedo(ind_wat_win,m)   = albedo_pars_f%pars_xy(0,j,i)
+                   surf_usm_h%albedo(m,ind_veg_wall)  = albedo_pars_f%pars_xy(0,j,i)
+                   surf_usm_h%albedo(m,ind_pav_green) = albedo_pars_f%pars_xy(0,j,i)
+                   surf_usm_h%albedo(m,ind_wat_win)   = albedo_pars_f%pars_xy(0,j,i)
                 ENDIF
              ENDDO 
@@ -1937,7 +1939,7 @@
                    j = surf_lsm_v(l)%j(m) + joff
                    IF ( albedo_pars_f%pars_xy(0,j,i) /= albedo_pars_f%fill )  THEN
-                      surf_lsm_v(l)%albedo(ind_veg_wall,m) = albedo_pars_f%pars_xy(0,j,i)
-                      surf_lsm_v(l)%albedo(ind_pav_green,m) = albedo_pars_f%pars_xy(0,j,i)
-                      surf_lsm_v(l)%albedo(ind_wat_win,m) = albedo_pars_f%pars_xy(0,j,i)
+                      surf_lsm_v(l)%albedo(m,ind_veg_wall) = albedo_pars_f%pars_xy(0,j,i)
+                      surf_lsm_v(l)%albedo(m,ind_pav_green) = albedo_pars_f%pars_xy(0,j,i)
+                      surf_lsm_v(l)%albedo(m,ind_wat_win) = albedo_pars_f%pars_xy(0,j,i)
                    ENDIF
                 ENDDO
@@ -1949,7 +1951,7 @@
                    j = surf_usm_v(l)%j(m) + joff
                    IF ( albedo_pars_f%pars_xy(0,j,i) /= albedo_pars_f%fill )  THEN
-                      surf_usm_v(l)%albedo(ind_veg_wall,m) = albedo_pars_f%pars_xy(0,j,i)
-                      surf_usm_v(l)%albedo(ind_pav_green,m) = albedo_pars_f%pars_xy(0,j,i)
-                      surf_usm_v(l)%albedo(ind_wat_win,m) = albedo_pars_f%pars_xy(0,j,i)
+                      surf_usm_v(l)%albedo(m,ind_veg_wall) = albedo_pars_f%pars_xy(0,j,i)
+                      surf_usm_v(l)%albedo(m,ind_pav_green) = albedo_pars_f%pars_xy(0,j,i)
+                      surf_usm_v(l)%albedo(m,ind_wat_win) = albedo_pars_f%pars_xy(0,j,i)
                    ENDIF
                 ENDDO
@@ -1975,21 +1977,21 @@
                       IF ( building_surface_pars_f%pars(ind_s_alb_b_wall,is) /=      &
                            building_surface_pars_f%fill )  THEN
-                         surf_usm_h%albedo(ind_veg_wall,m) =                         &
+                         surf_usm_h%albedo(m,ind_veg_wall) =                         &
                                   building_surface_pars_f%pars(ind_s_alb_b_wall,is)
-                         surf_usm_h%albedo_type(ind_veg_wall,m) = 0
+                         surf_usm_h%albedo_type(m,ind_veg_wall) = 0
                       ENDIF
 
                       IF ( building_surface_pars_f%pars(ind_s_alb_b_win,is) /=       &
                            building_surface_pars_f%fill )  THEN
-                         surf_usm_h%albedo(ind_wat_win,m) =                          &
+                         surf_usm_h%albedo(m,ind_wat_win) =                          &
                                   building_surface_pars_f%pars(ind_s_alb_b_win,is)
-                         surf_usm_h%albedo_type(ind_wat_win,m) = 0
+                         surf_usm_h%albedo_type(m,ind_wat_win) = 0
                       ENDIF
 
                       IF ( building_surface_pars_f%pars(ind_s_alb_b_green,is) /=     &
                            building_surface_pars_f%fill )  THEN
-                         surf_usm_h%albedo(ind_pav_green,m) =                        &
+                         surf_usm_h%albedo(m,ind_pav_green) =                        &
                                   building_surface_pars_f%pars(ind_s_alb_b_green,is)
-                         surf_usm_h%albedo_type(ind_pav_green,m) = 0
+                         surf_usm_h%albedo_type(m,ind_pav_green) = 0
                       ENDIF
 
@@ -2014,21 +2016,21 @@
                          IF ( building_surface_pars_f%pars(ind_s_alb_b_wall,is) /=      &
                               building_surface_pars_f%fill )  THEN
-                            surf_usm_v(l)%albedo(ind_veg_wall,m) =                      &
+                            surf_usm_v(l)%albedo(m,ind_veg_wall) =                      &
                                      building_surface_pars_f%pars(ind_s_alb_b_wall,is)
-                            surf_usm_v(l)%albedo_type(ind_veg_wall,m) = 0
+                            surf_usm_v(l)%albedo_type(m,ind_veg_wall) = 0
                          ENDIF
 
                          IF ( building_surface_pars_f%pars(ind_s_alb_b_win,is) /=       &
                               building_surface_pars_f%fill )  THEN
-                            surf_usm_v(l)%albedo(ind_wat_win,m) =                       &
+                            surf_usm_v(l)%albedo(m,ind_wat_win) =                       &
                                      building_surface_pars_f%pars(ind_s_alb_b_win,is)
-                            surf_usm_v(l)%albedo_type(ind_wat_win,m) = 0
+                            surf_usm_v(l)%albedo_type(m,ind_wat_win) = 0
                          ENDIF
 
                          IF ( building_surface_pars_f%pars(ind_s_alb_b_green,is) /=     &
                               building_surface_pars_f%fill )  THEN
-                            surf_usm_v(l)%albedo(ind_pav_green,m) =                     &
+                            surf_usm_v(l)%albedo(m,ind_pav_green) =                     &
                                      building_surface_pars_f%pars(ind_s_alb_b_green,is)
-                            surf_usm_v(l)%albedo_type(ind_pav_green,m) = 0
+                            surf_usm_v(l)%albedo_type(m,ind_pav_green) = 0
                          ENDIF
 
@@ -2047,21 +2049,21 @@
 !--       for wall/green/window (USM) or vegetation/pavement/water surfaces
 !--       (LSM). 
-          ALLOCATE ( surf_lsm_h%aldif(0:2,1:surf_lsm_h%ns)       )
-          ALLOCATE ( surf_lsm_h%aldir(0:2,1:surf_lsm_h%ns)       )
-          ALLOCATE ( surf_lsm_h%asdif(0:2,1:surf_lsm_h%ns)       )
-          ALLOCATE ( surf_lsm_h%asdir(0:2,1:surf_lsm_h%ns)       )
-          ALLOCATE ( surf_lsm_h%rrtm_aldif(0:2,1:surf_lsm_h%ns)  )
-          ALLOCATE ( surf_lsm_h%rrtm_aldir(0:2,1:surf_lsm_h%ns)  )
-          ALLOCATE ( surf_lsm_h%rrtm_asdif(0:2,1:surf_lsm_h%ns)  )
-          ALLOCATE ( surf_lsm_h%rrtm_asdir(0:2,1:surf_lsm_h%ns)  )
-
-          ALLOCATE ( surf_usm_h%aldif(0:2,1:surf_usm_h%ns)       )
-          ALLOCATE ( surf_usm_h%aldir(0:2,1:surf_usm_h%ns)       )
-          ALLOCATE ( surf_usm_h%asdif(0:2,1:surf_usm_h%ns)       )
-          ALLOCATE ( surf_usm_h%asdir(0:2,1:surf_usm_h%ns)       )
-          ALLOCATE ( surf_usm_h%rrtm_aldif(0:2,1:surf_usm_h%ns)  )
-          ALLOCATE ( surf_usm_h%rrtm_aldir(0:2,1:surf_usm_h%ns)  )
-          ALLOCATE ( surf_usm_h%rrtm_asdif(0:2,1:surf_usm_h%ns)  )
-          ALLOCATE ( surf_usm_h%rrtm_asdir(0:2,1:surf_usm_h%ns)  )
+          ALLOCATE ( surf_lsm_h%aldif(1:surf_lsm_h%ns,0:2)       )
+          ALLOCATE ( surf_lsm_h%aldir(1:surf_lsm_h%ns,0:2)       )
+          ALLOCATE ( surf_lsm_h%asdif(1:surf_lsm_h%ns,0:2)       )
+          ALLOCATE ( surf_lsm_h%asdir(1:surf_lsm_h%ns,0:2)       )
+          ALLOCATE ( surf_lsm_h%rrtm_aldif(1:surf_lsm_h%ns,0:2)  )
+          ALLOCATE ( surf_lsm_h%rrtm_aldir(1:surf_lsm_h%ns,0:2)  )
+          ALLOCATE ( surf_lsm_h%rrtm_asdif(1:surf_lsm_h%ns,0:2)  )
+          ALLOCATE ( surf_lsm_h%rrtm_asdir(1:surf_lsm_h%ns,0:2)  )
+
+          ALLOCATE ( surf_usm_h%aldif(1:surf_usm_h%ns,0:2)       )
+          ALLOCATE ( surf_usm_h%aldir(1:surf_usm_h%ns,0:2)       )
+          ALLOCATE ( surf_usm_h%asdif(1:surf_usm_h%ns,0:2)       )
+          ALLOCATE ( surf_usm_h%asdir(1:surf_usm_h%ns,0:2)       )
+          ALLOCATE ( surf_usm_h%rrtm_aldif(1:surf_usm_h%ns,0:2)  )
+          ALLOCATE ( surf_usm_h%rrtm_aldir(1:surf_usm_h%ns,0:2)  )
+          ALLOCATE ( surf_usm_h%rrtm_asdif(1:surf_usm_h%ns,0:2)  )
+          ALLOCATE ( surf_usm_h%rrtm_asdir(1:surf_usm_h%ns,0:2)  )
 
 !
@@ -2069,7 +2071,7 @@
 !--       implementations)
           IF ( .NOT. ALLOCATED(surf_lsm_h%albedo) )                            &
-             ALLOCATE( surf_lsm_h%albedo(0:2,1:surf_lsm_h%ns)     )
+             ALLOCATE( surf_lsm_h%albedo(1:surf_lsm_h%ns,0:2)     )
           IF ( .NOT. ALLOCATED(surf_usm_h%albedo) )                            &
-             ALLOCATE( surf_usm_h%albedo(0:2,1:surf_usm_h%ns)     )
+             ALLOCATE( surf_usm_h%albedo(1:surf_usm_h%ns,0:2)     )
 
 !
@@ -2077,30 +2079,30 @@
           DO  l = 0, 3
 
-             ALLOCATE ( surf_lsm_v(l)%aldif(0:2,1:surf_lsm_v(l)%ns)      )
-             ALLOCATE ( surf_lsm_v(l)%aldir(0:2,1:surf_lsm_v(l)%ns)      )
-             ALLOCATE ( surf_lsm_v(l)%asdif(0:2,1:surf_lsm_v(l)%ns)      )
-             ALLOCATE ( surf_lsm_v(l)%asdir(0:2,1:surf_lsm_v(l)%ns)      )
-
-             ALLOCATE ( surf_lsm_v(l)%rrtm_aldif(0:2,1:surf_lsm_v(l)%ns) )
-             ALLOCATE ( surf_lsm_v(l)%rrtm_aldir(0:2,1:surf_lsm_v(l)%ns) )
-             ALLOCATE ( surf_lsm_v(l)%rrtm_asdif(0:2,1:surf_lsm_v(l)%ns) )
-             ALLOCATE ( surf_lsm_v(l)%rrtm_asdir(0:2,1:surf_lsm_v(l)%ns) )
-
-             ALLOCATE ( surf_usm_v(l)%aldif(0:2,1:surf_usm_v(l)%ns)      )
-             ALLOCATE ( surf_usm_v(l)%aldir(0:2,1:surf_usm_v(l)%ns)      )
-             ALLOCATE ( surf_usm_v(l)%asdif(0:2,1:surf_usm_v(l)%ns)      )
-             ALLOCATE ( surf_usm_v(l)%asdir(0:2,1:surf_usm_v(l)%ns)      )
-
-             ALLOCATE ( surf_usm_v(l)%rrtm_aldif(0:2,1:surf_usm_v(l)%ns) )
-             ALLOCATE ( surf_usm_v(l)%rrtm_aldir(0:2,1:surf_usm_v(l)%ns) )
-             ALLOCATE ( surf_usm_v(l)%rrtm_asdif(0:2,1:surf_usm_v(l)%ns) )
-             ALLOCATE ( surf_usm_v(l)%rrtm_asdir(0:2,1:surf_usm_v(l)%ns) )
+             ALLOCATE ( surf_lsm_v(l)%aldif(1:surf_lsm_v(l)%ns,0:2)      )
+             ALLOCATE ( surf_lsm_v(l)%aldir(1:surf_lsm_v(l)%ns,0:2)      )
+             ALLOCATE ( surf_lsm_v(l)%asdif(1:surf_lsm_v(l)%ns,0:2)      )
+             ALLOCATE ( surf_lsm_v(l)%asdir(1:surf_lsm_v(l)%ns,0:2)      )
+
+             ALLOCATE ( surf_lsm_v(l)%rrtm_aldif(1:surf_lsm_v(l)%ns,0:2) )
+             ALLOCATE ( surf_lsm_v(l)%rrtm_aldir(1:surf_lsm_v(l)%ns,0:2) )
+             ALLOCATE ( surf_lsm_v(l)%rrtm_asdif(1:surf_lsm_v(l)%ns,0:2) )
+             ALLOCATE ( surf_lsm_v(l)%rrtm_asdir(1:surf_lsm_v(l)%ns,0:2) )
+
+             ALLOCATE ( surf_usm_v(l)%aldif(1:surf_usm_v(l)%ns,0:2)      )
+             ALLOCATE ( surf_usm_v(l)%aldir(1:surf_usm_v(l)%ns,0:2)      )
+             ALLOCATE ( surf_usm_v(l)%asdif(1:surf_usm_v(l)%ns,0:2)      )
+             ALLOCATE ( surf_usm_v(l)%asdir(1:surf_usm_v(l)%ns,0:2)      )
+
+             ALLOCATE ( surf_usm_v(l)%rrtm_aldif(1:surf_usm_v(l)%ns,0:2) )
+             ALLOCATE ( surf_usm_v(l)%rrtm_aldir(1:surf_usm_v(l)%ns,0:2) )
+             ALLOCATE ( surf_usm_v(l)%rrtm_asdif(1:surf_usm_v(l)%ns,0:2) )
+             ALLOCATE ( surf_usm_v(l)%rrtm_asdir(1:surf_usm_v(l)%ns,0:2) )
 !
 !--          Allocate broadband albedo (temporary for the current radiation
 !--          implementations)
              IF ( .NOT. ALLOCATED( surf_lsm_v(l)%albedo ) )                    &
-                ALLOCATE( surf_lsm_v(l)%albedo(0:2,1:surf_lsm_v(l)%ns) )
+                ALLOCATE( surf_lsm_v(l)%albedo(1:surf_lsm_v(l)%ns,0:2) )
              IF ( .NOT. ALLOCATED( surf_usm_v(l)%albedo ) )                    &
-                ALLOCATE( surf_usm_v(l)%albedo(0:2,1:surf_usm_v(l)%ns) )
+                ALLOCATE( surf_usm_v(l)%albedo(1:surf_usm_v(l)%ns,0:2) )
 
           ENDDO
@@ -2165,15 +2167,15 @@
 !--          Spectral albedos for vegetation/pavement/water surfaces
              DO  ind_type = 0, 2
-                IF ( surf_lsm_h%albedo_type(ind_type,m) /= 0 )  THEN
-                   surf_lsm_h%aldif(ind_type,m) =                              &
-                               albedo_pars(1,surf_lsm_h%albedo_type(ind_type,m))
-                   surf_lsm_h%asdif(ind_type,m) =                              &
-                               albedo_pars(2,surf_lsm_h%albedo_type(ind_type,m))
-                   surf_lsm_h%aldir(ind_type,m) =                              &
-                               albedo_pars(1,surf_lsm_h%albedo_type(ind_type,m))
-                   surf_lsm_h%asdir(ind_type,m) =                              &
-                               albedo_pars(2,surf_lsm_h%albedo_type(ind_type,m))
-                   surf_lsm_h%albedo(ind_type,m) =                             &
-                               albedo_pars(0,surf_lsm_h%albedo_type(ind_type,m))
+                IF ( surf_lsm_h%albedo_type(m,ind_type) /= 0 )  THEN
+                   surf_lsm_h%aldif(m,ind_type) =                              &
+                               albedo_pars(1,surf_lsm_h%albedo_type(m,ind_type))
+                   surf_lsm_h%asdif(m,ind_type) =                              &
+                               albedo_pars(2,surf_lsm_h%albedo_type(m,ind_type))
+                   surf_lsm_h%aldir(m,ind_type) =                              &
+                               albedo_pars(1,surf_lsm_h%albedo_type(m,ind_type))
+                   surf_lsm_h%asdir(m,ind_type) =                              &
+                               albedo_pars(2,surf_lsm_h%albedo_type(m,ind_type))
+                   surf_lsm_h%albedo(m,ind_type) =                             &
+                               albedo_pars(0,surf_lsm_h%albedo_type(m,ind_type))
                 ENDIF
              ENDDO
@@ -2188,15 +2190,15 @@
 !--             Spectral albedos for wall/green/window surfaces
                 DO  ind_type = 0, 2
-                   IF ( surf_usm_h%albedo_type(ind_type,m) /= 0 )  THEN
-                      surf_usm_h%aldif(ind_type,m) =                           &
-                               albedo_pars(1,surf_usm_h%albedo_type(ind_type,m))
-                      surf_usm_h%asdif(ind_type,m) =                           &
-                               albedo_pars(2,surf_usm_h%albedo_type(ind_type,m))
-                      surf_usm_h%aldir(ind_type,m) =                           &
-                               albedo_pars(1,surf_usm_h%albedo_type(ind_type,m))
-                      surf_usm_h%asdir(ind_type,m) =                           &
-                               albedo_pars(2,surf_usm_h%albedo_type(ind_type,m))
-                      surf_usm_h%albedo(ind_type,m) =                          &
-                               albedo_pars(0,surf_usm_h%albedo_type(ind_type,m))
+                   IF ( surf_usm_h%albedo_type(m,ind_type) /= 0 )  THEN
+                      surf_usm_h%aldif(m,ind_type) =                           &
+                               albedo_pars(1,surf_usm_h%albedo_type(m,ind_type))
+                      surf_usm_h%asdif(m,ind_type) =                           &
+                               albedo_pars(2,surf_usm_h%albedo_type(m,ind_type))
+                      surf_usm_h%aldir(m,ind_type) =                           &
+                               albedo_pars(1,surf_usm_h%albedo_type(m,ind_type))
+                      surf_usm_h%asdir(m,ind_type) =                           &
+                               albedo_pars(2,surf_usm_h%albedo_type(m,ind_type))
+                      surf_usm_h%albedo(m,ind_type) =                          &
+                               albedo_pars(0,surf_usm_h%albedo_type(m,ind_type))
                    ENDIF
                 ENDDO
@@ -2211,15 +2213,15 @@
 !--             Spectral albedos for vegetation/pavement/water surfaces
                 DO  ind_type = 0, 2
-                   IF ( surf_lsm_v(l)%albedo_type(ind_type,m) /= 0 )  THEN
-                      surf_lsm_v(l)%aldif(ind_type,m) =                        &
-                            albedo_pars(1,surf_lsm_v(l)%albedo_type(ind_type,m))
-                      surf_lsm_v(l)%asdif(ind_type,m) =                        &
-                            albedo_pars(2,surf_lsm_v(l)%albedo_type(ind_type,m))
-                      surf_lsm_v(l)%aldir(ind_type,m) =                        &
-                            albedo_pars(1,surf_lsm_v(l)%albedo_type(ind_type,m))
-                      surf_lsm_v(l)%asdir(ind_type,m) =                        &
-                            albedo_pars(2,surf_lsm_v(l)%albedo_type(ind_type,m))
-                      surf_lsm_v(l)%albedo(ind_type,m) =                       &
-                            albedo_pars(0,surf_lsm_v(l)%albedo_type(ind_type,m))
+                   IF ( surf_lsm_v(l)%albedo_type(m,ind_type) /= 0 )  THEN
+                      surf_lsm_v(l)%aldif(m,ind_type) =                        &
+                            albedo_pars(1,surf_lsm_v(l)%albedo_type(m,ind_type))
+                      surf_lsm_v(l)%asdif(m,ind_type) =                        &
+                            albedo_pars(2,surf_lsm_v(l)%albedo_type(m,ind_type))
+                      surf_lsm_v(l)%aldir(m,ind_type) =                        &
+                            albedo_pars(1,surf_lsm_v(l)%albedo_type(m,ind_type))
+                      surf_lsm_v(l)%asdir(m,ind_type) =                        &
+                            albedo_pars(2,surf_lsm_v(l)%albedo_type(m,ind_type))
+                      surf_lsm_v(l)%albedo(m,ind_type) =                       &
+                            albedo_pars(0,surf_lsm_v(l)%albedo_type(m,ind_type))
                    ENDIF
                 ENDDO
@@ -2233,15 +2235,15 @@
 !--                Spectral albedos for wall/green/window surfaces
                    DO  ind_type = 0, 2
-                      IF ( surf_usm_v(l)%albedo_type(ind_type,m) /= 0 )  THEN
-                         surf_usm_v(l)%aldif(ind_type,m) =                     &
-                            albedo_pars(1,surf_usm_v(l)%albedo_type(ind_type,m))
-                         surf_usm_v(l)%asdif(ind_type,m) =                     &
-                            albedo_pars(2,surf_usm_v(l)%albedo_type(ind_type,m))
-                         surf_usm_v(l)%aldir(ind_type,m) =                     &
-                            albedo_pars(1,surf_usm_v(l)%albedo_type(ind_type,m))
-                         surf_usm_v(l)%asdir(ind_type,m) =                     &
-                            albedo_pars(2,surf_usm_v(l)%albedo_type(ind_type,m))
-                         surf_usm_v(l)%albedo(ind_type,m) =                    &
-                            albedo_pars(0,surf_usm_v(l)%albedo_type(ind_type,m))
+                      IF ( surf_usm_v(l)%albedo_type(m,ind_type) /= 0 )  THEN
+                         surf_usm_v(l)%aldif(m,ind_type) =                     &
+                            albedo_pars(1,surf_usm_v(l)%albedo_type(m,ind_type))
+                         surf_usm_v(l)%asdif(m,ind_type) =                     &
+                            albedo_pars(2,surf_usm_v(l)%albedo_type(m,ind_type))
+                         surf_usm_v(l)%aldir(m,ind_type) =                     &
+                            albedo_pars(1,surf_usm_v(l)%albedo_type(m,ind_type))
+                         surf_usm_v(l)%asdir(m,ind_type) =                     &
+                            albedo_pars(2,surf_usm_v(l)%albedo_type(m,ind_type))
+                         surf_usm_v(l)%albedo(m,ind_type) =                    &
+                            albedo_pars(0,surf_usm_v(l)%albedo_type(m,ind_type))
                       ENDIF
                    ENDDO
@@ -2263,17 +2265,17 @@
                 DO  ind_type = 0, 2
                    IF ( albedo_pars_f%pars_xy(0,j,i) /= albedo_pars_f%fill )   &
-                      surf_lsm_h%albedo(ind_type,m) =                          &
+                      surf_lsm_h%albedo(m,ind_type) =                          &
                                              albedo_pars_f%pars_xy(0,j,i)      
                    IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )   &
-                      surf_lsm_h%aldir(ind_type,m) =                           &
+                      surf_lsm_h%aldir(m,ind_type) =                           &
                                              albedo_pars_f%pars_xy(1,j,i)      
                    IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )   &
-                      surf_lsm_h%aldif(ind_type,m) =                           &
+                      surf_lsm_h%aldif(m,ind_type) =                           &
                                              albedo_pars_f%pars_xy(1,j,i)      
                    IF ( albedo_pars_f%pars_xy(2,j,i) /= albedo_pars_f%fill )   &
-                      surf_lsm_h%asdir(ind_type,m) =                           &
+                      surf_lsm_h%asdir(m,ind_type) =                           &
                                              albedo_pars_f%pars_xy(2,j,i)      
                    IF ( albedo_pars_f%pars_xy(2,j,i) /= albedo_pars_f%fill )   &
-                      surf_lsm_h%asdif(ind_type,m) =                           &
+                      surf_lsm_h%asdif(m,ind_type) =                           &
                                              albedo_pars_f%pars_xy(2,j,i)
                 ENDDO
@@ -2290,5 +2292,5 @@
                    DO  ind_type = 0, 2
                       IF ( albedo_pars_f%pars_xy(0,j,i) /= albedo_pars_f%fill )&
-                         surf_usm_h%albedo(ind_type,m) =                       &
+                         surf_usm_h%albedo(m,ind_type) =                       &
                                              albedo_pars_f%pars_xy(0,j,i)
                    ENDDO
@@ -2296,13 +2298,13 @@
 !--                Spectral albedos especially for building wall surfaces
                    IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )  THEN
-                      surf_usm_h%aldir(ind_veg_wall,m) =                       &
+                      surf_usm_h%aldir(m,ind_veg_wall) =                       &
                                                 albedo_pars_f%pars_xy(1,j,i)
-                      surf_usm_h%aldif(ind_veg_wall,m) =                       &
+                      surf_usm_h%aldif(m,ind_veg_wall) =                       &
                                                 albedo_pars_f%pars_xy(1,j,i)
                    ENDIF
                    IF ( albedo_pars_f%pars_xy(2,j,i) /= albedo_pars_f%fill )  THEN
-                      surf_usm_h%asdir(ind_veg_wall,m) =                       &
+                      surf_usm_h%asdir(m,ind_veg_wall) =                       &
                                                 albedo_pars_f%pars_xy(2,j,i)
-                      surf_usm_h%asdif(ind_veg_wall,m) =                       &
+                      surf_usm_h%asdif(m,ind_veg_wall) =                       &
                                                 albedo_pars_f%pars_xy(2,j,i)
                    ENDIF
